<?
/*
(C) 2004-2013 DatuX - info@datux.nl

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

	require_once ("../common.php");
	require_once ("network.php");
	require_once ("../vpn/openswan.php");

	$IFCONFIG="/sbin/ifconfig";
	$DHCPCD="/sbin/dhcpcd";
	$POSTUP_SCRIPT="/etc/network/network.up";


	//runlogged($cmd)
	function NetExec($params)
	{
		//global $IFCONFIG;

		$exitcode=Cmd("$params </dev/null","", $out, $err);

		$err=implode("\n",$err);
		$out=implode("\n",$out);
		//LogInfo("$params");

		//echo "params: $params\n";
		//something whent wrong?
		if ($err)
		{
			LogWarn(_LogNetworkError($err,$params));
			return $err;
		}
		return false;
	}

	//converts a rulearray into a command
	//add=1 to create add parameters
	//add=0 to create delete parameters
	function Rule2Cmd($rule, $rulenumber)
	{
	//-R Prevents dhcpcd from replacing existing /etc/resolv.conf file.

		//ifconfig ethX ipadress netmask 255.XXXX
		//or
		//dhcpcd ethX -h hostname  and maybe -R
		global $IFCONFIG;
		global $DHCPCD;
		//is it dhcp?
		if ($rule['ipordhcp']=="dhcp")
		{
			$dhcprule =  "$DHCPCD eth$rule[networkadaptor] ";
			if($rule['netmask'] !="")
				$dhcprule .=" -h $rule[netmask] -I $rule[netmask]";
			if($rule['dns']==0)
				$dhcprule.= " -R";
			//option -R Prevents dhcpcd from replacing existing /etc/resolv.conf file.
			/*-t <timeout>
              Specifies (in seconds ) for how long dhcpcd will try to get an IP address. The default is 60 seconds.   dhcpcd  will  not
              fork  into  background  until  it gets a valid IP address in which case dhcpcd will return 0 to the parent process.  In a
              case dhcpcd times out before receiving a valid IP address from DHCP server dhcpcd will return exit code 1 to  the  parent
              process.
			*/
			$dhcprule = "killall dhcpcd 2>/dev/null; /sbin/dhcpcd -k 2>/dev/null;sleep 1;closefd /usr/bin/pgrphack $dhcprule -t 30 -d";
			$ret = $dhcprule;
		}
		else
		{
			//just use static ip
			$ret = "$IFCONFIG eth".$rule['networkadaptor'].":".$rulenumber." ".$rule['ipordhcp']." netmask ".$rule['netmask'];
		}
		return $ret;
	}



	function IfConfigChangeRule($newrule,$rulenumber)
	{
		if ($newrule)
		{
			$param=Rule2Cmd($newrule,$rulenumber);
			$err=NetExec($param);
		}
		return ($err);
	}

	function IfConfigRestart($ConfigFile)
	{
		LogInfo(_LogRestartingNetwork());
		global $IFCONFIG;
		$rules=ReadNetworkRules($ConfigFile,1);
		$TotalLines = $rules['TotalLines'];
		unset($rules['TotalLines']);
		IfConfigCleanup();
		//LogInfo(_LogNetworkDown());
		//apply zah rules
		$ruleNumber = 0;

		//eerst dhcp
		IfConfigChangeRule($rules['dhcp'], 0);

		//static ip adressen
		foreach ($rules as $ruletxt=>$rule)
		{
			if($rule['ipordhcp']!="dhcp")
			{
				IfConfigChangeRule($rule, $ruleNumber);
				$ruleNumber++;
			}
		}
//		if(GetTotalNetworkAdaptors() > 1 )
//			NetExec("$IFCONFIG eth1 up");

		global $POSTUP_SCRIPT;
		if (is_executable($POSTUP_SCRIPT))
		{
			NetExec($POSTUP_SCRIPT);
		}
		//LogInfo(_LogNetworkRestartComplete());
	}

	//this does al default things dhcpcd down etc..
	function IfconfigCleanup()
	{
		//altijd alles wissen!
		$nrules=10;

		global $IFCONFIG;
		global $DHCPCD;
		global $ZONES;

		//Kill all dhcpcd processes.
		NetExec("killall dhcpcd 2>/dev/null; /sbin/dhcpcd -k 2>/dev/null");

		//Throw all aliasses from all interfaces down.
		foreach($ZONES as $INTERFACE => $ZONE) {
			for($a=0;$a<$nrules;$a++) {
				NetExec("$IFCONFIG $INTERFACE:$a 0.0.0.0 2>/dev/null");
			}
		}

		//clean main interfaces and up them (up is neccesary for hyperV hv_netvsc)
		foreach($ZONES as $INTERFACE => $ZONE) {
			NetExec("$IFCONFIG $INTERFACE 0.0.0.0 2>/dev/null");
			NetExec("$IFCONFIG $INTERFACE up 2>/dev/null");
		}
		NetExec("$IFCONFIG lo 127.0.0.1");
		//for zarafa spooler and others to allow other src adresses
		NetExec("$IFCONFIG lo:2 127.0.0.2 netmask 255.255.255.255");
		NetExec("$IFCONFIG lo:3 127.0.0.3 netmask 255.255.255.255");
	}
?>
